﻿package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.display.Shape;
	import flash.geom.Rectangle;
	import flash.display.CapsStyle;
	import flash.display.LineScaleMode;
	
	
	public class Spectre extends Sprite{
		
		private var _son:Sound;
		private var _canal:SoundChannel;
		private var _locx:Array = new Array();
		private var _newloc:Array = new Array();
		private var _monolith:Shape = new Shape();
		private var _cleaner:Shape = new Shape();

		
		public function Spectre(sound:String){
			_son = new Sound(new URLRequest(sound));
			_canal = _son.play();
			
			_posx = 200;
			_posy = 100;
			
			_cleaner.graphics.beginFill(0xffffff, 0.0);
			_cleaner.graphics.drawRect(0,0,500,500);
				
			addChild(_monolith);
			addChild(_cleaner);
		
			for(var i:int = 0; i<5; i++){
				_locx.push(_posx);
				_newloc.push(_posx);
			}

			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}
		
		private function onEnterFrame(evenement:Event):void{
			//Crée le tableau d'octets et le remplit de données
			var spectre:ByteArray = new ByteArray();
			SoundMixer.computeSpectrum(spectre);
			const VELOCITY:int = 5;
			const AMPLITUDE:int = 100;
			
			_monolith.graphics.clear();
			
			for(var i:int = 0; i<10; i++){
				_monolith.graphics.lineStyle(60, 0x000000);
				_monolith.graphics.moveTo(_posx+i*10, _posy);
				_monolith.graphics.curveTo(_locx[0]+i*10, _posy+50, _locx[1]+i*10, _posy+100);
				_monolith.graphics.curveTo(_locx[2]+i*10, _posy+150, _locx[3]+i*10, _posy+200);
				_monolith.graphics.curveTo(_locx[4]+i*10, _posy+250, _posx+i*10, _posy+300);
				}

			
			this.removeChild(_monolith);
			this.removeChild(_cleaner);
			this.addChild(_monolith);
			this.addChild(_cleaner);
			
			for(var j:int = 0; j<5; j++){
				ecart = _locx[j] - _newloc[j];
				_locx[j] -= ecart / VELOCITY;
				
				if(ecart < 2 && ecart > -2){
					//trace("point " + j + " stable !");
					_newloc[j] = _posx + spectre.readFloat()*AMPLITUDE;
					}
			}
		}
	}
	
}